#ifndef __CFILE__
#define __CFILE__

using XMLIOSERVER::XML::XMLNode;
using XMLIOSERVER::XML::THashAttributes;

namespace XMLIOSERVER
{
   class CFile : public ObjectTemplate<CFile>, public FileAttribut
   {
      public:

         CFile(void) : ObjectTemplate<CFile>(), FileAttribut(), vfieldGroup(NULL)
         {/* Ne rien faire de plus */}
         CFile(const string& _id) : ObjectTemplate<CFile>(_id), FileAttribut(), vfieldGroup(NULL)
         {/* Ne rien faire de plus */}

         static string GetName(void) { return ("file"); }

         void parse (XMLNode& _node)
         {
            string name = _node.getElementName();
            THashAttributes attributes;

            /// PARSING GESTION DES ATTRIBUTS ///
            _node.getAttributes(attributes);
            this->setAttributes(attributes);
            attributes.clear();

            /// PARSING POUR GESION DES ENFANTS ///
            if (_node.goToChildElement() and hasId())
            { // Si la définition du fichier intégre des champs et si le fichier est identifié.
               _node.goToParentElement();
               vfieldGroup = CreateInstanceAndParse<FieldGroup>(attributes, _node, getId().c_str(), false );
            }
         }

         virtual bool hasChild(void) const { return (vfieldGroup != NULL); }
         virtual void printChild(ostream& out) const { out << *vfieldGroup << std::endl; }
         virtual void resolveDescInheritance(const AttributRegistrar* _parent = 0)
         { addAttributes(*_parent); if(vfieldGroup != NULL) vfieldGroup->resolveDescInheritance(); }

         FieldGroup* getVirtualFieldGroup(void) { return (vfieldGroup); }

         ~CFile(void)
         { if(vfieldGroup != NULL) delete vfieldGroup; }

      private :

         FieldGroup* vfieldGroup; // FieldGroup "virtuel"

   }; // class CFile

}; // namespace XMLIOSERVER

#endif // __CFILE__
